=== debian/changelog ===
falcosecurity-libs (0.11.3+repack-6ubuntu1) mantic; urgency=medium

  * debian/patches/1147.patch:
    - cherry-pick upstream fix for arm64
  * Ignore failures on armhf

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 08 Sep 2023 11:17:53 +0200

falcosecurity-libs (0.11.3+repack-6) unstable; urgency=medium

  * Test suite link succeeds on 32bit platforms

 -- Dima Kogan <dkogan@debian.org>  Wed, 06 Sep 2023 09:44:06 -0700

falcosecurity-libs (0.11.3+repack-5) unstable; urgency=medium

  * Build fixes bug fix

 -- Dima Kogan <dkogan@debian.org>  Wed, 06 Sep 2023 01:02:56 -0700

falcosecurity-libs (0.11.3+repack-4) unstable; urgency=medium

  * More build fixes for 32-bit arches

 -- Dima Kogan <dkogan@debian.org>  Wed, 06 Sep 2023 00:08:17 -0700

falcosecurity-libs (0.11.3+repack-3) unstable; urgency=medium

  * Build fixes for mips64el, 32-bit arm

 -- Dima Kogan <dkogan@debian.org>  Tue, 05 Sep 2023 23:17:40 -0700

falcosecurity-libs (0.11.3+repack-2) unstable; urgency=medium

  * Patch to fix build on less-popular architectures

 -- Dima Kogan <dkogan@debian.org>  Tue, 05 Sep 2023 20:44:52 -0700

falcosecurity-libs (0.11.3+repack-1) unstable; urgency=medium

  * New upstream release (Closes: #1034881, #1037646)
    - The libscap, libsinsp shared object split into subcomponent libraries

    - Headers shipped into /usr/include/falcosecurity and not
      /usr/include/falcosecurity-libs to conform with upstream

 -- Dima Kogan <dkogan@debian.org>  Sat, 15 Jul 2023 08:52:13 -0700

falcosecurity-libs (0.9.1-1) unstable; urgency=medium

  * New upstream release

 -- Dima Kogan <dkogan@debian.org>  Thu, 05 Jan 2023 23:49:50 -0800
